> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://mailchimp.com/developer/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://mailchimp.com/developer/_mcp/server.

# Add promo code

POST https://api.mailchimp.com/3.0/ecommerce/stores/{store_id}/promo-rules/{promo_rule_id}/promo-codes
Content-Type: application/json

Add a new promo code to a store.

Reference: https://mailchimp.com/developer/marketing/api/ecommerce/create-store-promo-rule-promo-code

## Authentication

- `Authorization` header (bearer token, required) — Authorization using a Mailchimp API key (a.k.a. Bearer token)
- `Authorization` header (bearer token, required) — Authorization using OAuth

## Request

### Path parameters

- `store_id` (string, required) — The store id.
- `promo_rule_id` (string, required) — The id for the promo rule of a store.

### Body (application/json)

This endpoint expects an object.

- `code` (string, required) — The discount code. Restricted to UTF-8 characters with max length 50.
- `id` (string, required) — A unique identifier for the promo code. Restricted to UTF-8 characters with max length 50.
- `redemption_url` (string, required) — The url that should be used in the promotion campaign restricted to UTF-8 characters with max length 2000.
- `created_at_foreign` (string, optional) — The date and time the promotion was created in ISO 8601 format.
- `enabled` (boolean, optional) — Whether the promo code is currently enabled.
- `updated_at_foreign` (string, optional) — The date and time the promotion was updated in ISO 8601 format.
- `usage_count` (integer, optional) — Number of times promo code has been used.

## Response

### 200

- `_links` (list of ECommercePromoCodeLinksItems, optional) — A list of link types and descriptions for the API schema documents.
- `code` (string, optional) — The discount code. Restricted to UTF-8 characters with max length 50.
- `created_at_foreign` (datetime, optional) — The date and time the promotion was created in ISO 8601 format.
- `enabled` (boolean, optional) — Whether the promo code is currently enabled.
- `id` (string, optional) — A unique identifier for the promo Code.
- `redemption_url` (string, optional) — The url that should be used in the promotion campaign restricted to UTF-8 characters with max length 2000.
- `updated_at_foreign` (datetime, optional) — The date and time the promotion was updated in ISO 8601 format.
- `usage_count` (integer, optional) — Number of times promo code has been used.

## Types

### ECommercePromoCodeLinksItems

This object represents a link from the resource where it is found to another resource or action that may be performed.

- `href` (string, optional) — This property contains a fully-qualified URL that can be called to retrieve the linked resource or perform the linked action.
- `method` (enum, optional) — The HTTP method that should be used when accessing the URL defined in 'href'.
  - Allowed values: `GET`, `POST`, `PUT`, `PATCH`, `DELETE`, `OPTIONS`, `HEAD`
- `rel` (string, optional) — As with an HTML 'rel' attribute, this describes the type of link.
- `schema` (string, optional) — For HTTP methods that can receive bodies (POST and PUT), this is a URL representing the schema that the body should conform to.
- `targetSchema` (string, optional) — For GETs, this is a URL representing the schema that the response should conform to.

## Examples

**Request**

```json
{
  "code": "summersale",
  "id": "string",
  "redemption_url": "A url that applies promo code directly at checkout or a url that points to sale page or store url"
}
```

**Response**

```json
{
  "_links": [
    {
      "href": "string",
      "method": "GET",
      "rel": "string",
      "schema": "string",
      "targetSchema": "string"
    }
  ],
  "code": "summersale",
  "created_at_foreign": "2024-01-15T09:30:00Z",
  "enabled": "true",
  "id": "string",
  "redemption_url": "A url that applies promo code directly at checkout or a url that points to sale page or store url",
  "updated_at_foreign": "2024-01-15T09:30:00Z",
  "usage_count": 1
}
```

**SDK Code**

```python
import requests

url = "https://api.mailchimp.com/3.0/ecommerce/stores/store_id/promo-rules/promo_rule_id/promo-codes"

payload = {
    "code": "summersale",
    "id": "string",
    "redemption_url": "A url that applies promo code directly at checkout or a url that points to sale page or store url"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.mailchimp.com/3.0/ecommerce/stores/store_id/promo-rules/promo_rule_id/promo-codes';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"code":"summersale","id":"string","redemption_url":"A url that applies promo code directly at checkout or a url that points to sale page or store url"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.mailchimp.com/3.0/ecommerce/stores/store_id/promo-rules/promo_rule_id/promo-codes"

	payload := strings.NewReader("{\n  \"code\": \"summersale\",\n  \"id\": \"string\",\n  \"redemption_url\": \"A url that applies promo code directly at checkout or a url that points to sale page or store url\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.mailchimp.com/3.0/ecommerce/stores/store_id/promo-rules/promo_rule_id/promo-codes")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"code\": \"summersale\",\n  \"id\": \"string\",\n  \"redemption_url\": \"A url that applies promo code directly at checkout or a url that points to sale page or store url\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.mailchimp.com/3.0/ecommerce/stores/store_id/promo-rules/promo_rule_id/promo-codes")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"code\": \"summersale\",\n  \"id\": \"string\",\n  \"redemption_url\": \"A url that applies promo code directly at checkout or a url that points to sale page or store url\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.mailchimp.com/3.0/ecommerce/stores/store_id/promo-rules/promo_rule_id/promo-codes', [
  'body' => '{
  "code": "summersale",
  "id": "string",
  "redemption_url": "A url that applies promo code directly at checkout or a url that points to sale page or store url"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.mailchimp.com/3.0/ecommerce/stores/store_id/promo-rules/promo_rule_id/promo-codes");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"code\": \"summersale\",\n  \"id\": \"string\",\n  \"redemption_url\": \"A url that applies promo code directly at checkout or a url that points to sale page or store url\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "code": "summersale",
  "id": "string",
  "redemption_url": "A url that applies promo code directly at checkout or a url that points to sale page or store url"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.mailchimp.com/3.0/ecommerce/stores/store_id/promo-rules/promo_rule_id/promo-codes")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```